#include <iostream>


bool match(const char* pattern, const char* number) {
    if (*pattern == 0 || *number == 0)
        return *pattern == *number;
    if (*pattern == *number || *pattern == '?')
        return match(pattern + 1, number + 1);
    if (*pattern == '*')
        return match(pattern, number + 1) || match(pattern + 1, number + 1);
    return false;
}


int main() {
    int N;
    std::cin >> N;

    char book[10000][10];
    for (int i = 0; i < N; ++i)
        std::cin >> book[i];

    int Q;
    std::cin >> Q;
    while (Q--) {
        char number[10];
        std::cin >> number;

        int count = 0;
        for (int i = 0; i < N; ++i) {
            if (match(number, book[i]))
                count++;
        }

        std::cout << count << '\n';
    }

    return 0;
}
